if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Drown Vehicles","Drowning Vehicles","$DrowningVehicles::Enabled","list On 1 Off 0","Server_DrowningVehicles",1,0,0,"DrowningVehicles_Toggle");
	RTB_registerPref("Drowning Rate","Drowning Vehicles","$DrowningVehicles::Rate","int 100 1000","Server_DrowningVehicles",500,0,0);
}
else
{
	$DrowningVehicles::Enabled = 1;
	$DrowningVehicles::Rate = 500;
}

package DrowningVehicles
{
	function WheeledVehicleData::onEnterLiquid(%this, %obj, %cov, %type)
	{
		%obj.inLiquid = true;
		if(!%obj.getDatablock().canBreathe)
			%obj.drownSched = schedule($DrowningVehicles::Rate, 0, "VehicleDrowning", %obj);
	}

	function WheeledVehicleData::onLeaveLiquid(%this, %obj, %cov, %type)
	{
		%obj.inLiquid = false;
	}

	function FlyingVehicleData::onEnterLiquid(%this, %obj, %cov, %type)
	{
		%obj.inLiquid = true;
		%obj.drownSched = schedule($DrowningVehicles::Rate, 0, "VehicleDrowning", %obj);
	}

	function FlyingVehicleData::onLeaveLiquid(%this, %obj, %cov, %type)
	{
		%obj.inLiquid = false;
	}
};

if($DrowningVehicles::Enabled)
	activatePackage(DrowningVehicles);

function DrowningVehicles_Toggle(%oldVal, %newVal)
{
	if(%newVal)
		activatePackage(DrowningVehicles);
	else
		deactivatePackage(DrowningVehicles);
}

function VehicleDrowning(%obj)
{
	if(!isObject(%obj) || !%obj.inLiquid) return;

	%obj.damage(%obj,%obj.getPosition(),5,$DamageType::Vehicle);

	%obj.drownSched = schedule($DrowningVehicles::Rate, 0, "VehicleDrowning", %obj);
}